unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, UnitAddRecordForm, Contnrs, CoolTrayIcon,
  AppEvnts, SyncObJs, Menus, aboutAuthor, RusClipboard, whatsNew, XPMan;

const
  RECORDS_FILE_NAME           =  'records.dat';
  THERE_ARE_NO_RECORDS        =  ' .   '
                                +'     .';
  PROGRAMM_IS_ALREDY_LAUCNHED =  '   .';
  CONFIRM_MSG                 =  '     ? '
                                +'    .';
type
  TRecordNumber = integer;
  TRecord = class
    procedure setRecordTitle(const ATitle: wideString);
    procedure setContentText(const AText: wideString);
  private
    recordTitle:   wideString;
    recordContent: wideString;
  end;

  TForm1 = class(TForm)
    ListBoxRecordsTitlesList: TListBox;
    Label1: TLabel;
    BitBtnAddNewRecord: TBitBtn;
    BitBtnEraseCurrentRecord: TBitBtn;
    Memo1: TMemo;
    Button1: TButton;
    CoolTrayIcon1: TCoolTrayIcon;
    ApplicationEvents1: TApplicationEvents;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    LabelUsedCharactersNumber: TLabel;
    Label3: TLabel;
    N3: TMenuItem;
    procedure BitBtnAddNewRecordClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure showRecord(const index: TRecordNumber);
    procedure ListBoxRecordsTitlesListClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBoxRecordsTitlesListDblClick(Sender: TObject);
    procedure renameRecordByNumber(const ANumber: TRecordNumber; const AName: wideString);
    procedure BitBtnEraseCurrentRecordClick(Sender: TObject);
    procedure enableMemo;
    procedure disableMemo;
    procedure Button1Click(Sender: TObject);
    procedure CoolTrayIcon1Click(Sender: TObject);
    procedure restoreFromTray;
    procedure CoolTrayIcon1BalloonHintClick(Sender: TObject);
    procedure ApplicationEvents1Minimize(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure preventSecondInstanceLaunching;
    procedure Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure saveRecordsToFile;
    function  getRecordsNumber: TRecordNumber;
    function  getRecordByIndex(const AIndex: TRecordNumber): TRecord;
    procedure addToRecordsList(const ARecord: TRecord);
    function  getRenamedRecordNumber: TRecordNumber;
    procedure N2Click(Sender: TObject);
    procedure ListBoxRecordsTitlesListMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure Label3Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
  private
    fullFileName        : TFileName;
    checkEvent          : TEvent;
    recordsList         : TObjectList;
    renamedRecordNumber : TRecordNumber;
    clipboard           : TRusClipboard;
    ImJustShowingRecord : boolean;
    nextWindowHandler   : HWND;
    {
    ImJustShowingRecord - , ,    .
       ,       
    }
    procedure drawClipboard(var msg: TWMDrawClipboard); message WM_DRAWCLIPBOARD;
  public

  end;

procedure showNumber(const ANumber: integer); //   
procedure showError(const msg: string);

var
  Form1: TForm1;

implementation

{$R *.dfm}

// -----------------------------------------------------------------------------

procedure TForm1.restoreFromTray;
begin
  coolTrayIcon1.ShowTaskbarIcon;
  application.Restore;
  coolTrayIcon1.IconVisible:=false;
end;

// -----------------------------------------------------------------------------

//    .    
procedure showNumber(const ANumber: integer);
begin
  ShowMessage(intToStr(ANumber));
end;

// -----------------------------------------------------------------------------

//      ,   
procedure showError(const msg: string);
begin
  messageDlg(msg, mtError, [mbOK], 0);
end;

// -----------------------------------------------------------------------------

procedure createForm2;
begin
  if not assigned(form2) then begin
    form2:=TForm2.Create(form1);
  end;
end;

// -----------------------------------------------------------------------------

procedure TForm1.enableMemo;
begin
  self.Memo1.Enabled:=true;
  self.Memo1.Color:=clWhite;
end;

// -----------------------------------------------------------------------------

procedure TForm1.disableMemo;
begin
  Memo1.Enabled:=false;
  Memo1.Color:=self.Color;
end;

// -----------------------------------------------------------------------------

procedure TRecord.setRecordTitle(const ATitle: wideString);
begin
  self.recordTitle:=ATitle;
end;

// -----------------------------------------------------------------------------

procedure TRecord.setContentText(const AText: wideString);
begin
  self.recordContent:=AText;
end;

// -----------------------------------------------------------------------------

procedure TForm1.renameRecordByNumber(const ANumber: TRecordNumber;
                                      const AName: wideString);
begin
  (recordsList.Items[ANumber] as TRecord).recordTitle:=AName;
end;

// -----------------------------------------------------------------------------

procedure TForm1.showRecord(const index: TRecordNumber);
var
  currentRecord: TRecord;
begin
  currentRecord:=recordsList.items[index] as TRecord;

  label1.Caption:=currentRecord.recordTitle;
  ImJustShowingRecord:=true;
  memo1.Text:=currentRecord.recordContent;
  ImJustShowingRecord:=false;
end;

// -----------------------------------------------------------------------------

procedure TForm1.BitBtnAddNewRecordClick(Sender: TObject);
begin
  try
   createForm2;
  except
   showError('     ');
   exit;
  end;

  renamedRecordNumber:=-1; // ,  ,   

  form2.Edit1.Clear;
  form2.Caption:='  ';
  form2.ShowModal;
end;

// -----------------------------------------------------------------------------

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  recordsList.Clear;
  recordsList.Free;
  changeClipboardChain(handle, nextWindowHandler);
  clipboard.Free;
end;

// -----------------------------------------------------------------------------

procedure TForm1.ListBoxRecordsTitlesListClick(Sender: TObject);
begin
  showRecord(ListBoxRecordsTitlesList.ItemIndex);
end;

// -----------------------------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);
var
  fileStream    : TFileStream;
  recordsNumber : TRecordNumber;
  i             : TRecordNumber;
  rec           : TRecord;

  function readFieldValueFromFile: wideString;
  var
    stringSizeToRead    : longInt;
    arrayForInputString : array of wideChar;
  begin
    fileStream.Read(stringSizeToRead, sizeOf(longInt));
    setLength(arrayForInputString, stringSizeToRead);
    fileStream.Read(arrayForInputString[0], stringSizeToRead);
    result:= wideString(arrayForInputString);
    finalize(arrayForInputString);
  end;

begin
  preventSecondInstanceLaunching;
  clipboard:=TRusClipboard.Create;
  application.HintHidePause:=-1; //    
  nextWindowHandler:=setClipboardViewer(handle);
{
 :
< >
<  . 1>< . 1><  . 1>< . 1>
...............................................................................
<  . N>< . N><  . N>< . N>
}

  //       
    fullFileName:=extractFilePath(Application.exeName) + RECORDS_FILE_NAME;

  recordsList:=TObjectList.Create;

  if not fileExists(fullFileName) then begin
    memo1.Text:=THERE_ARE_NO_RECORDS;
    exit;
  end;

  fileStream:=TFileStream.Create(fullFileName, fmOpenRead);
  try
    fileStream.Read(recordsNumber, sizeOf(TRecordNumber));
    for i:=0 to recordsNumber - 1 do begin
       rec:=TRecord.create;

      //      
        rec.setRecordTitle(readFieldValueFromFile);

      //      
        rec.setcontentText(readFieldValueFromFile);

      recordsList.Add(rec);
    end;
  finally
    fileStream.Free;
  end;

  //      
    for i:=0 to recordsList.Count - 1 do begin
      rec:=recordsList.Items[i] as TRecord;
      ListBoxRecordsTitlesList.Items.Add( rec.recordTitle )
    end;

    enableMemo;
    ListBoxRecordsTitlesList.ItemIndex:=0;
    showRecord(0);

    BitBtnEraseCurrentRecord.Enabled:=true;
    button1.Enabled:=true;
end;

// -----------------------------------------------------------------------------

procedure TForm1.ListBoxRecordsTitlesListDblClick(Sender: TObject);
begin
  try
    createForm2;
  except
    showError('     ');
    exit;
  end;

  renamedRecordNumber:=ListBoxRecordsTitlesList.ItemIndex;

  form2.Caption:=' ';
  form2.Edit1.Text:=ListBoxRecordsTitlesList.Items[renamedRecordNumber];

  form2.ShowModal;
end;

// -----------------------------------------------------------------------------

procedure TForm1.BitBtnEraseCurrentRecordClick(Sender: TObject);
var
  recordNumberToRemove : TRecordNumber;
  confirmAnswer        : integer;
begin
  confirmAnswer:=MessageBox(
    handle,
    PChar(CONFIRM_MSG),
    PChar(' '),
    MB_ICONQUESTION + MB_YESNO
  );
  if confirmAnswer = IDNO then begin
    exit;
  end;

  recordNumberToRemove:=ListBoxRecordsTitlesList.ItemIndex;

  //      ,    
    if recordNumberToRemove = recordsList.Count - 1 then begin
      ListBoxRecordsTitlesList.ItemIndex:=recordNumberToRemove - 1
    end else begin
      ListBoxRecordsTitlesList.ItemIndex:=recordNumberToRemove + 1;
    end;

  recordsList.Delete(recordNumberToRemove);
  ListBoxRecordsTitlesList.items.Delete(recordNumberToRemove);

  if recordsList.Count = 0 then begin
    BitBtnEraseCurrentRecord.Enabled:=false;
    label1.Caption:='( )';
    memo1.text:='';
    disableMemo;
    memo1.Text:=THERE_ARE_NO_RECORDS;
    button1.Enabled:=false;
    //    ,    0    
      deleteFile(fullFileName);;
  end else begin
    showRecord(ListBoxRecordsTitlesList.ItemIndex);
    saveRecordsToFile;
  end;
end;

// -----------------------------------------------------------------------------

//    memo   
procedure TForm1.Button1Click(Sender: TObject);
begin
  if memo1.Text = '' then begin
    memo1.SetFocus;
    exit;
  end;

  clipboard.AsText:=memo1.Text;

  //       
    application.Minimize;
    coolTrayIcon1.IconVisible:=true;
    coolTrayIcon1.HideTaskbarIcon;
    coolTrayIcon1.ShowBalloonHint(
      '',
      '    .',
      bitInfo,
      10
    );
end;

// -----------------------------------------------------------------------------

//        
procedure TForm1.CoolTrayIcon1Click(Sender: TObject);
begin
  restoreFromTray;
end;

// -----------------------------------------------------------------------------

procedure TForm1.CoolTrayIcon1BalloonHintClick(Sender: TObject);
begin
  restoreFromTray;
end;

// -----------------------------------------------------------------------------

procedure TForm1.ApplicationEvents1Minimize(Sender: TObject);
begin
  coolTrayIcon1.HideTaskbarIcon;
  coolTrayIcon1.IconVisible:=true;
  coolTrayIcon1.ShowBalloonHint(
    '   ',
    '    ,   .',
     bitInfo,
     10
  );
end;

// -----------------------------------------------------------------------------

//  ,    Memo
procedure TForm1.Memo1Change(Sender: TObject);
var
  currentRecordNumber: TRecordNumber;
begin
  //   ,   
    if recordsList.Count = 0 then begin
      exit;
    end;

  currentRecordNumber:=ListBoxRecordsTitlesList.ItemIndex;
  (recordsList.Items[currentRecordNumber] as TRecord).setContentText(memo1.Text);

  LabelUsedCharactersNumber.Caption:=' : '
    + intToStr(length(memo1.Text));

  //     ,   ,    .
    if ImJustShowingRecord then begin
      exit;
    end;

  saveRecordsToFile;
end;

// -----------------------------------------------------------------------------

procedure TForm1.preventSecondInstanceLaunching;
// : http://www.programmersforum.ru/showpost.php?p=158890&postcount=5
begin
  //   -  ,    
  checkEvent:=TEvent.Create(nil, false, true, '00vvkkwekc0dj4jjkf93ikfk3002991');
  if checkEvent.WaitFor(10) <> wrSignaled then begin
    showError(PROGRAMM_IS_ALREDY_LAUCNHED);
    application.Terminate;
  end;
end;

// -----------------------------------------------------------------------------

//   CTRL+A
procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin 
  if (ssCTRL in shift) AND (key = ord('A')) then begin
    memo1.SelectAll;
  end;
end;

// -----------------------------------------------------------------------------

procedure TForm1.saveRecordsToFile;
var
  fileStream : TFileStream;
  i          : TRecordNumber;
  rec        : TRecord;

  procedure writeStringAndSizeToFile(const AString: wideString);
  var
    stringSizeToWrite: longInt;
  begin
    stringSizeToWrite:=2*length(AString);
    fileStream.Write(stringSizeToWrite, sizeOf(longInt));
    fileStream.Write(AString[1], stringSizeToWrite);
  end;

begin
{
 :
< >
<  . 1>< . 1><  . 1>< . 1>
...............................................................................
<  . N>< . N><  . N>< . N>
}
  if recordsList.Count > 0 then begin
    fileStream:=TFileStream.Create(fullFileName, fmCreate);
    try
      fileStream.Write(recordsList.count, sizeOf(TRecordNumber));
      for i:=0 to recordsList.Count-1 do begin
        rec:=recordsList.Items[i] as TRecord;

        //       
          writeStringAndSizeToFile(rec.recordTitle);

        //       
          writeStringAndSizeToFile(rec.recordContent);
      end;
    finally
      fileStream.Free
    end;
  end;
end;

// -----------------------------------------------------------------------------

function TForm1.getRecordsNumber: TRecordNumber;
begin
  result:=recordsList.Count;
end;

// -----------------------------------------------------------------------------

function TForm1.getRecordByIndex(const AIndex: TRecordNumber): TRecord;
begin
  result:=recordsList.items[AIndex] as TRecord;
end;

// -----------------------------------------------------------------------------

procedure TForm1.addToRecordsList(const ARecord: TRecord);
begin
  recordsList.Add(ARecord);
end;

// -----------------------------------------------------------------------------

function TForm1.getRenamedRecordNumber: TRecordNumber;
begin
  result:=renamedRecordNumber;
end;

// -----------------------------------------------------------------------------

procedure TForm1.N2Click(Sender: TObject);
begin
  if not assigned(form3) then begin
    try
      form3:=TForm3.Create(self);
    except
      showError('  ');
    end;
  end;

  form3.ShowModal;
end;

// -----------------------------------------------------------------------------

//   ,     
procedure TForm1.ListBoxRecordsTitlesListMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
//  http://pblog.ru/lab/?p=414
var
  idx: TRecordNumber;
begin
  with Sender as TListBox do begin
    idx := ItemAtPos(Point(x,y),True);
    if idx < 0 then begin
      exit;
    end;
    Hint := '';
    if Canvas.TextWidth(Items[idx]) > Width - 45 then begin
      // 45   
      Hint:=Items[idx];
    end;
  end;
end;

// -----------------------------------------------------------------------------

procedure TForm1.Label3Click(Sender: TObject);
var
  answer: integer;
begin
  if (memo1.Text = '') or (recordsList.Count = 0) then begin
    exit;
  end;

  answer:=messageBox(
    handle,
    PChar('  ?     .'),
    PChar(' '),
    MB_ICONQUESTION + MB_YESNO
  );
  if answer = IDYES then begin
    memo1.text:='';
  end;
end;

// -----------------------------------------------------------------------------

procedure TForm1.drawClipboard(var msg: TWMDrawClipboard);
begin
  //         "    "
  //    .   ,     
  try
    clipboard.AsText;
  except
  end;
end;

// -----------------------------------------------------------------------------

procedure TForm1.N3Click(Sender: TObject);
begin
  if not assigned(form4) then begin
    try
      form4:=TForm4.Create(self);
    except
      showError('  .');
      exit;
    end;
  end;

  form4.ShowModal;
end;

end.
